var login;
var loginView;
var helpWindow;
var deviceInfoWindow;
var loginWindow;

var mainWindow = Ti.UI.createWindow({
	backgroundColor : 'black',
	fullscreen : true,
	exitOnClose : true,
	activity : {
		/*Optionen Menu nur unter Android*/
		onCreateOptionsMenu : function(e) {
			var menu = e.menu;
			var menuItemHelp = menu.add({
				title : "Help"
			});
			menuItemHelp.addEventListener('click', showHelpWindow);

			var menuItemDeviceInfo = menu.add({
				title : "Device Info"
			});
			//menuItemDeviceInfo.setIcon("images/ic_menu_add.png");
			menuItemDeviceInfo.addEventListener('click', showDeviceInfoWindow);

			var menuItemLogin = menu.add({
				title : "Login"
			});
			menuItemLogin.addEventListener('click', showLoginWindow);
		}
	}
});

var height = Ti.Platform.displayCaps.platformHeight;
var width = Ti.Platform.displayCaps.platformWidth;

var changeOrientation = false;

/*Wenn die Standard Orientierung nicht Portrait ist: Höhe und Breite vertauschen*/
if(mainWindow.getOrientation() == Ti.UI.LANDSCAPE_LEFT || mainWindow.getOrientation() == Ti.UI.LANDSCAPE_RIGHT) {
	changeOrientation = true;
	height = Ti.Platform.displayCaps.platformWidth
	width = Ti.Platform.displayCaps.platformHeight;
	if(Ti.Platform.osname == 'android')
		width += 48;
}

/*Orientierung auf Portrait Format festsetzen*/
mainWindow.orientationModes = [Titanium.UI.PORTRAIT];

/*Schritgröße für die verschiedene OS definieren*/
if(Ti.Platform.osname == 'iphone') {
	Ti.App.Properties.setInt('fontSize', 20);
	Ti.App.Properties.setInt('fontSizeLogin', 20);
	Ti.App.Properties.setInt('fontSizePerm', 20);
	Ti.App.Properties.setInt('fontSizeSlideDown', 13);
	Ti.App.Properties.setInt('fontSizeHelp', 20);
}
if(Ti.Platform.osname == 'ipad') {
	Ti.App.Properties.setInt('fontSize', 50);
	Ti.App.Properties.setInt('fontSizeLogin', 30);
	Ti.App.Properties.setInt('fontSizePerm', 30);
	Ti.App.Properties.setInt('fontSizeSlideDown', 30);
	Ti.App.Properties.setInt('fontSizeHelp', 30);
}
if(Ti.Platform.osname == 'android') {
	Ti.App.Properties.setInt('fontSize', 20);
	Ti.App.Properties.setInt('fontSizeLogin', 20);
	Ti.App.Properties.setInt('fontSizePerm', 20);
	if(changeOrientation)
		Ti.App.Properties.setInt('fontSizeHelp', 40);
	else
		Ti.App.Properties.setInt('fontSizeHelp', 20);
}
/*Events Listener festlegen*/
mainWindow.addEventListener('close', function(e) {
	Ti.App.fireEvent('closeSocket');
});

Ti.App.addEventListener('socketConnected', socketConnected);
Ti.App.addEventListener('showLoginWindow', showLoginWindow);
Ti.App.addEventListener('showHelpWindow', showHelpWindow);
Ti.App.addEventListener('showDeviceInfoWindow', showDeviceInfoWindow);

var LoginScreen = require('ui/loginScreen');
loginView = LoginScreen.createLoginScreen({
	'height' : height
});
login = LoginScreen.loadLoginData();

/*Größe der einzelnen Views berechnen*/
var slideDownSizeHeight = height * 0.05;
var slideViewHeight = height * 0.70;
var permanentViewHeight = height * 0.25;

var PermanentView = require('ui/permanentView');
var SlideView = require('ui/slideView');
var SlideDownView = require('ui/slideDownView');

/*Views erzeugen*/
var permanentView = PermanentView.createPermanentView({
	'height' : permanentViewHeight,
	'width' : width
});
var slideView = SlideView.createSlideView({
	'height' : slideViewHeight,
	'top' : slideDownSizeHeight,
	'width' : width,
	'changeOrientation' : changeOrientation
});
var slideDownView = SlideDownView.createSlideDownView({
	'height' : slideDownSizeHeight,
	'width' : width
});

/*Views zum Windows hinzufügen*/
mainWindow.add(slideView);
mainWindow.add(permanentView);
mainWindow.add(slideDownView);

mainWindow.open();

/*Login Screen nur anzeigen, wenn keine Login Daten gespeichert sind*/
if(!login) {
	showLoginWindow();
}

function socketConnected(e) {
	if(!login) {
		closeLoginWindow();
	}

	//Regelmäßiges senden eines Kommandos, um die Verbindung zum TV aufrecht zu halten
	setInterval(function() {
		Ti.API.error('Interval');
		Ti.App.fireEvent('sendMessage', {
			id : 'deviceName'
		});
	}, 170000);
	Ti.App.fireEvent('sendMessage', {
		id : 'powerOnIP'
	});
	//Ti.App.fireEvent('sendMessage',{id : 'test3'});
}

/*
 * Login Window anzeigen
 */
function showLoginWindow(e) {
	if(loginWindow) {
		loginWindow.open();
		return;
	}
	loginWindow = Ti.UI.createWindow({
		title : 'Login Data',
		modal : true
	});
	loginWindow.add(loginView);
	loginWindow.open();
	Ti.App.addEventListener('closeLoginWindow', closeLoginWindow);
}

function closeLoginWindow() {
	loginWindow.close();
}

/*
 * Hilfe Window anzeigen
 */
function showHelpWindow(e) {
	if(helpWindow) {
		helpWindow.open();
		return;
	}
	var HelpView = require('ui/helpView');
	var helpView = HelpView.createHelpView({
		'height' : height,
		'width' : width
	});
	helpWindow = Ti.UI.createWindow({
		title : 'Help Text',
		modal : true
	});
	helpWindow.add(helpView);
	helpWindow.open();
	Ti.App.addEventListener('closeHelpWindow', closeHelpWindow);
}

function closeHelpWindow() {
	helpWindow.close();
}

function showDeviceInfoWindow(e) {
	if(deviceInfoWindow) {
		deviceInfoWindow.open();
		return;
	}
	var DeviceInfoView = require('ui/deviceInfoView');
	var deviceInfoView = DeviceInfoView.createDeviceInfoView({});
	deviceInfoWindow = Ti.UI.createWindow({
		title : L('deviceInfo'),
		modal : true
	});

	deviceInfoWindow.add(deviceInfoView);
	deviceInfoWindow.open();
	Ti.App.addEventListener('closeDeviceInfoWindow', closeDeviceInfoWindow);
}

function closeDeviceInfoWindow(e) {
	deviceInfoWindow.close();
}