var hostname;
var controlPort;
var loginID;
var password;
var tcpSocket;
var isConnected = false;
var carriageReturn = '\r';
var currentVideoFormat = 0;
var currentAudioFormat = 0;
var currentInputChannel = 0;
var currentAVMode = 0;
var currentVolume = 10;
var currentChannelDesc = 'DTVD'
var lastCodeSend = '';
var threeDEnabled = false
var deviceName = '', modelName = '', softwareVer, ipVer = '';
var arrayInitialized = false;
var functionToCode = new Object();
var isTeletext = false;
var isHalfText = false;
var lastChannel = '';
var lastChannelNumber = 0;
var isPowerOn = false;

/*
 * Erzeugt den Socket und initialisiert Event Listener
 */
exports.createSocket = function(args) {
	hostname = args.hostname;
	controlPort = args.port;
	loginID = args.loginID;
	password = args.password;

	if(!arrayInitialized)
		initFuntionArray();

	if(isConnected) {
		tcpSocket.close();
		tcpSocket = null;
	}

	//create socket
	tcpSocket = getSocket();
	tcpSocket.connect();

	//add global listener for sending messages
	Ti.App.addEventListener('sendMessage', sendMessage);
	Ti.App.addEventListener('closeSocket', closeSocket);
	Ti.App.addEventListener('reconnect', reconnect);
	Ti.App.addEventListener('getDeviceInfo', getDeviceInfo);
	Ti.App.addEventListener('socketConnected', socketConnected);
	Ti.App.addEventListener('resume', reconnect);
	Ti.App.addEventListener('pause', function() {
		if(tcpSocket.state == Ti.Network.SOCKET_CONNECTED)
			tcpSocket.close
	});
};
/*
 * Erzeugt den Socket
 */
function getSocket() {
	var socket = Ti.Network.Socket.createTCP({
		host : hostname,
		port : controlPort,
		timeout : 10000,
		connected : function(e) {
			isConnected = true;
			Ti.App.fireEvent('changeConnectionState', {
				state : isConnected
			});
			Ti.API.debug('Connected');
			saveLoginData();
			Ti.App.fireEvent('socketConnected', {});
		},
		error : function(e) {
			Ti.API.debug('Error (' + e.errorCode + '): ' + e.error);
			isConnected = false;
			Ti.App.fireEvent('changeConnectionState', {
				state : isConnected
			});
		}
	});
	return socket
}

function socketConnected() {
	//Ti.API.info(loginID + ':' + password);
	if(loginID == '' || password == '') {
		var writeBuffer = Ti.createBuffer({
			value : 'VOLM????' + carriageReturn
		})
		var readBuffer = Ti.createBuffer({
			length : 128
		});

		try {
			tcpSocket.write(writeBuffer);
			var bytesRead = tcpSocket.read(readBuffer);
			if(readBuffer.toString().search('ERR') != -1) {
				isPowerOn = false;
				Ti.API.info('POWER OFF');
			} else {
				isPowerOn = true;
				Ti.API.info('POWER ON');
			}
		} catch(ex) {
			Ti.App.fireEvent('changeConnectionState', {
				state : false
			});
		}
	} else {
		var readBuffer = Ti.createBuffer({
			length : 128
		});

		try {
			var bytesRead = tcpSocket.read(readBuffer);
			isPowerOn = true;
			parseData(readBuffer.toString());
		} catch(ex) {
			Ti.App.fireEvent('changeConnectionState', {
				state : false
			});
		}
	}
}

/*
 * Speichert die Login Daten
 */
function saveLoginData() {
	var file = Titanium.Filesystem.getFile(Titanium.Filesystem.applicationDataDirectory, 'loginData.txt');
	var string = hostname + '\n' + controlPort + '\n' + loginID + '\n' + password;
	file.write(string);
}

function sendLoginID() {

	var buffer = Ti.createBuffer({
		value : loginID + carriageReturn
	});

	/*Empfangspuffer*/
	var readBuffer = Ti.createBuffer({
		length : 128
	});

	if(tcpSocket.state == Titanium.Network.Socket.CONNECTED) {
		try {
			tcpSocket.write(buffer);
			var bytesRead = tcpSocket.read(readBuffer);
			parseData(readBuffer.toString());
		} catch(ex) {
			Ti.App.fireEvent('changeConnectionState', {
				state : false
			});
		}
	}
}

function sendPassword() {
	var buffer = Ti.createBuffer({
		value : password + carriageReturn
	});

	/*Empfangspuffer*/
	var readBuffer = Ti.createBuffer({
		length : 128
	});

	if(tcpSocket.state == Titanium.Network.Socket.CONNECTED) {
		try {
			tcpSocket.write(buffer);
			var bytesRead = tcpSocket.read(readBuffer);
			parseData(readBuffer.toString());
		} catch(ex) {
			Ti.App.fireEvent('changeConnectionState', {
				state : false
			});
		}
	}
}

/*
 * Parsen der Antwort vom Fernseher
 */
function parseData(received) {
	Ti.API.info('RECEIVED: ' + received);
	if(received.search('Login:') != -1)
		sendLoginID();

	if(received.search('Password:') != -1)
		sendPassword();

	if(received.search('OK') != -1) {
		//Ti.API.info('OK received');
		if(lastCodeSend.search('TEXT1') != -1) {
			if(isTeletext)
				if(isHalfText) {
					isTeletext = false;
					isHalfText = false;
				} else
					isHalfText = true;
			else {
				isTeletext = true;
				isHalfText = false;
				lastChannel = currentChannelDesc;
			}
		}
	}

	if(received.search('ERR') != -1) {
		//Ti.API.info('ERR received (' + lastCodeSend + ')');
		if(lastCodeSend.search('TEXT1') != -1)
			isTeletext = false;
	}

	if(lastCodeSend == "VOLM????")
		currentVolume = parseInt(received);

	if(lastCodeSend == functionToCode["deviceName"]) {
		deviceName = received;
		Ti.App.fireEvent('insertDeviceInfo', {
			deviceName : deviceName,
			modelName : modelName,
			softwareVer : softwareVer,
			ipVer : ipVer
		})
	}

	if(lastCodeSend == functionToCode["modelName"]) {
		modelName = received;
		Ti.App.fireEvent('insertDeviceInfo', {
			deviceName : deviceName,
			modelName : modelName,
			softwareVer : softwareVer,
			ipVer : ipVer
		})
	}

	if(lastCodeSend == functionToCode["swVersion"]) {
		softwareVer = received;
		Ti.App.fireEvent('insertDeviceInfo', {
			deviceName : deviceName,
			modelName : modelName,
			softwareVer : softwareVer,
			ipVer : ipVer
		})
	}

	if(lastCodeSend == functionToCode["ipProtVer"]) {
		ipVer = received;
		Ti.App.fireEvent('insertDeviceInfo', {
			deviceName : deviceName,
			modelName : modelName,
			softwareVer : softwareVer,
			ipVer : ipVer
		})
	}
}

/*
 * Erzeugt den Socket erneut
 */
function reconnect() {
	closeSocket();
	tcpSocket = null;
	tcpSocket = getSocket();
	tcpSocket.connect();
}

/*
 * Schließt den Socket
 */
function closeSocket(e) {
	if(tcpSocket.state == Titanium.Network.Socket.CONNECTED)
		tcpSocket.close();
}

/*
 * Schickt eine Nachricht an den Fernseher
 */
function sendMessage(args) {
	var id = args.id;
	var number = args.number;
	var code;

	if(tcpSocket.state != Titanium.Network.Socket.CONNECTED) {
		reconnect();
	}

	if(id == 'tvPower') {
		if(isPowerOn) {
			id = 'tvPowerOff';
			isPowerOn = false;
		} else {
			id = 'tvPowerOn';
			isPowerOn = true;
		}
	}

	var message = functionToCode[id];

	/*Lautstärke nach oben hin begrenzen*/
	if(id == 'volUp') {
		sendMessage({
			id : 'volInitial'
		});
		currentVolume++;
		if(currentVolume > 60)
			currentVolume = 60;
		message = functionToCode['volume'] + '' + currentVolume

		if(currentVolume < 10)
			message += '   ';
		else
			message += '  ';
	}

	/*Lautstärke nach unten hin begrenzen*/
	if(id == 'volDown') {
		sendMessage({
			id : 'volInitial'
		});
		currentVolume--;
		if(currentVolume < 0)
			currentVolume = 0;
		message = functionToCode['volume'] + '' + currentVolume

		if(currentVolume < 10)
			message += '   ';
		else
			message += '  ';
	}

	if(id == 'atv') {
		currentChannelDesc = 'DCCH';
		if(lastChannelNumber == 0)
			number = 1;
		else
			number = lastChannelNumber;
		id = 'progNumber';

		//return;
	} else if(id == 'dtv') {
		currentChannelDesc = 'DTVD';
		if(lastChannelNumber == 0)
			number = 1;
		else
			number = lastChannelNumber;

		//id = 'progNumber';
		//return;
	} else if(id == 'sat') {
		currentChannelDesc = 'DSC1';
		if(lastChannelNumber == 0)
			number = 1;
		else
			number = lastChannelNumber;
		id = 'progNumber';
		//return;
	}

	if(isTeletext)
		currentChannelDesc = 'DCPG';
	else if(lastChannel != '')
		currentChannelDesc = lastChannel;

	/*Programmnummer überprüfen*/
	if(id == 'progNumber') {
		switch (currentChannelDesc) {
			case 'DCCH':
				if(number > 0 && number < 100) {
					message = currentChannelDesc + number + '    ';
					message = message.substr(0, 8);
					lastChannelNumber = number;
				} else {
					Ti.API.error('socket.js: Program number out of range: ' + number);
					return;
				}
				break;

			case 'DCPG':
				if(number > 99 && number < 900) {
					message = currentChannelDesc + number + '    ';
					message = message.substr(0, 8);
					lastChannelNumber = number;
				} else {
					Ti.API.error('socket.js: Teletext number out of range: ' + number);
					return;
				}
				break;

			case 'DTVD':
				if(number > 0 && number < 1000) {
					message = currentChannelDesc + number + '    ';
					message = message.substr(0, 8);
					lastChannelNumber = number;
				} else {
					Ti.API.error('socket.js: Program number out of range: ' + number);
					return;
				}
				break;

			case 'DSC1':

				if(number > 0 && number < 10000) {
					message = currentChannelDesc + number + '    ';
					message = message.substr(0, 8);
					lastChannelNumber = number;
				} else {
					Ti.API.error('socket.js: Program number out of range: ' + number);
					return;
				}
				break;
		}
	}

	if( typeof message === 'undefined')
		return;

	//Ti.API.debug('socket.js: ' + message);
	lastCodeSend = message;
	message = message + carriageReturn;

	/*Sendepuffer*/
	var buffer = Ti.createBuffer({
		value : message
	});

	/*Empfangspuffer*/
	var readBuffer = Ti.createBuffer({
		length : 128
	});

	/*Nachricht schicken und auf Antwort warten*/
	if(tcpSocket.state == Titanium.Network.Socket.CONNECTED) {
		try {
			Ti.API.info('SEND: ' + message);
			tcpSocket.write(buffer);
			var bytesRead = tcpSocket.read(readBuffer);
			parseData(readBuffer.toString());
		} catch(ex) {
			Ti.App.fireEvent('changeConnectionState', {
				state : false
			});
		}
	}
}

function getDeviceInfo(e) {

	sendMessage({
		id : 'deviceName'
	});
	sendMessage({
		id : 'modelName'
	});
	sendMessage({
		id : 'swVersion'
	});
	sendMessage({
		id : 'ipProtVer'
	});
}

function writeCallback(e) {

}

/*
 * Initialisiert das Array für die Kommandos
 */
function initFuntionArray() {
	functionToCode["tvPowerOff"] = "POWR0   ";
	functionToCode["tvPowerOn"] = "POWR1   ";

	functionToCode["changeInput"] = "ITGD    ";

	functionToCode["avMode"] = "AVMD0   ";
	functionToCode["standard"] = "AVMD1   ";
	functionToCode["film"] = "AVMD2   ";
	functionToCode["games"] = "AVMD3   ";
	functionToCode["user"] = "AVMD4   ";
	functionToCode["dynamicallyConst"] = "AVMD5   ";
	functionToCode["dynamically"] = "AVMD6   ";
	functionToCode["pc"] = "AVMD7   ";
	functionToCode["xvColor"] = "AVMD8   ";
	functionToCode["standard3D"] = "AVMD14  ";
	functionToCode["film3D"] = "AVMD15  ";
	functionToCode["games3D"] = "AVMD16  ";
	functionToCode["auto"] = "AVMD100 ";

	functionToCode["audioMode"] = "ACHA    ";
	functionToCode["volume"] = "VOLM";
	functionToCode["volInitial"] = "VOLM????";
	functionToCode["mute"] = "MUTE0   ";
	functionToCode["deviceName"] = "TVNM1   ";
	functionToCode["modelName"] = "MNRD1   ";
	functionToCode["swVersion"] = "SWVN1   ";
	functionToCode["ipProtVer"] = "IPPV1   ";
	functionToCode["tv"] = "ITVD    ";
	functionToCode["dtv"] = "IDTV    ";
	functionToCode["avd"] = "IAVD";
	functionToCode["threeD"] = "TDCH";
	functionToCode["inputB"] = "INP1";
	functionToCode["surSound"] = "ACSU";
	functionToCode["hPos"] = "HPOS";
	functionToCode["vPos"] = "VPOS";
	functionToCode["clck"] = "CLCK";
	functionToCode["hphse"] = "PHSE";
	functionToCode["dcch"] = "DCCH";
	functionToCode["chUp"] = "CHUP    ";
	functionToCode["chDown"] = "CHDW    ";
	functionToCode["navUp"] = "RCKY41  ";
	functionToCode["navDown"] = "RCKY42  ";
	functionToCode["navLeft"] = "RCKY43  ";
	functionToCode["navRight"] = "RCKY44  ";
	functionToCode["navEnter"] = "RCKY40  ";
	functionToCode["menu"] = "RCKY38  ";
	functionToCode["dtvd"] = "DTVD";
	functionToCode["ideg"] = "IDEG    ";
	functionToCode["dsc1"] = "DSC1";
	functionToCode["dsc2"] = "DSC2";
	functionToCode["dsc3"] = "DSC3";
	functionToCode["dsc4"] = "DCS4";
	functionToCode["dtup"] = "DTUP    ";
	functionToCode["dtdw"] = "DTDW    ";

	functionToCode["oftm"] = "OFTM";

	functionToCode['3DOff'] = "TDCH0   ";
	functionToCode['2D/3D'] = "TDCH1   ";
	functionToCode['sideBySide'] = "TDCH2   ";
	functionToCode['oneUpTheOther'] = "TDCH3   ";
	functionToCode['3D/2DsideBySide'] = "TDCH4   ";
	functionToCode['3D/2DoneUpTheOther'] = "TDCH5   ";
	functionToCode['3DAuto'] = "TDCH6   ";
	functionToCode['3D/2D'] = "TDCH7   ";

	functionToCode['videoMode'] = "WIDE0   ";
	functionToCode['normal'] = "WIDE1   ";
	functionToCode['zoom14:9'] = "WIDE2   ";
	functionToCode['panorama'] = "WIDE3   ";
	functionToCode['full(AV)'] = "WIDE4   ";
	functionToCode['cinema16:9'] = "WIDE5   ";
	functionToCode['cinema14:9'] = "WIDE6   ";
	functionToCode['normal(PC)'] = "WIDE7   ";
	functionToCode['cinema(PC)'] = "WIDE8   ";
	functionToCode['full(PC)'] = "WIDE9   ";
	functionToCode['pointByPoint'] = "WIDE10  ";
	functionToCode['underscan'] = "WIDE11  ";
	functionToCode['auto'] = "WIDE12  ";
	functionToCode['original'] = "WIDE13  ";

	functionToCode['teletext'] = "TEXT1   ";

	functionToCode['powerOnIP'] = 'RSPW2   ';
}