var nameTextField;
var loginNameTextField;
var passwordTextField;
var portTextField;
var errorLabel;

/*
 * Generiert den Login Screen
 */
exports.createLoginScreen = function(args) {
	var height = 70;
	var fontSize = Ti.App.Properties.getInt('fontSizeLogin');

	var nameLabel = Ti.UI.createLabel({
		textid : 'deviceName',
		id : 'nameLabel',
		width : '30%',
		left : 0,
		height : height,
		top : 0,
		color : 'white',
		font : {
			fontSize : fontSize
		}
	});
	
	nameTextField = Ti.UI.createTextField({
		left : '30%',
		width : '70%',
		height : height,
		top : 0,
		backgroundColor : 'white',
		font : {
			fontSize : fontSize
		}
	});

	var loginNameLabel = Ti.UI.createLabel({
		textid : 'loginID',
		width : '30%',
		left : 0,
		height : height,
		top : height + 10,
		color : 'white',
		font : {
			fontSize : fontSize
		}
	});
	
	loginNameTextField = Ti.UI.createTextField({
		left : '30%',
		width : '70%',
		height : height,
		top : height + 10,
		backgroundColor : 'white',
		font : {
			fontSize : fontSize
		}
	});

	var passwordLabel = Ti.UI.createLabel({
		textid : 'password',
		width : '30%',
		left : 0,
		height : height,
		top : 2 * height + 20,
		color : 'white',
		font : {
			fontSize : fontSize
		}
	});
	
	passwordTextField = Ti.UI.createTextField({
		left : '30%',
		width : '70%',
		height : height,
		top : 2 * height + 20,
		backgroundColor : 'white',
		font : {
			fontSize : fontSize
		}
	});

	var portLabel = Ti.UI.createLabel({
		textid : 'port',
		width : '30%',
		left : 0,
		height : height,
		top : 3 * height + 30,
		color : 'white',
		font : {
			fontSize : fontSize
		}
	});
	
	portTextField = Ti.UI.createTextField({
		left : '30%',
		width : '70%',
		keyboardType : Ti.UI.KEYBOARD_PHONE_PAD,
		height : height,
		top : 3 * height + 30,
		backgroundColor : 'white',
		font : {
			fontSize : fontSize
		}
	});
	errorLabel = Ti.UI.createLabel({
		top : 4 * height,
		left : 0,
		color : 'red',
		font : {
			fontSize : fontSize
		}
	})

	var connectButton = Ti.UI.createButton({
		title : 'Connect',
		width : '30%',
		left : '13%',
		height : height,
		top : 4 * height + 40,
		font : {
			fontSize : fontSize
		}
	});
	connectButton.addEventListener('click', handleEvent);

	var cancelButton = Ti.UI.createButton({
		title : 'Cancel',
		width : '30%',
		left : '46%',
		height : height,
		top : 4 * height + 40,
		font : {
			fontSize : fontSize
		}
	});
	cancelButton.addEventListener('click', handleCancelButton);

	var view = Ti.UI.createView({
		backgroundColor : 'black'
	});

	view.add(nameLabel);
	view.add(nameTextField);
	view.add(loginNameLabel);
	view.add(loginNameTextField);
	view.add(passwordLabel);
	view.add(passwordTextField);
	view.add(portLabel);
	view.add(portTextField);
	view.add(connectButton);
	view.add(cancelButton);
	view.add(errorLabel);

	return view;
};
/*
 * Lädt die gespeicherten Login Daten, falls vorhanden
 */
exports.loadLoginData = function() {
	var file = Titanium.Filesystem.getFile(Titanium.Filesystem.applicationDataDirectory, 'loginData.txt');
	if(file.exists()) {
		var content = file.read().text;
		var stringArray = content.split('\n');

		var hostname = stringArray[0];
		var port = stringArray[1];
		var loginID = stringArray[2];
		var password = stringArray[3];

		nameTextField.value = hostname;
		loginNameTextField.value = loginID;
		portTextField.value = port;
		passwordTextField.value = password;

		var connectionString = 'hostname:' + hostname + ',port:' + port + ',loginID:' + loginID + ',password:' + password;

		connect({
			'hostname' : hostname,
			'port' : port,
			'loginID' : loginID,
			'password' : password
		});
		return true;

	}

	return false;
};
/*
 * Verbindet sich zu einem entfernten TCP Socket
 */
function connect(args) {
	var hostname = args.hostname;
	var port = args.port;
	var loginID = args.loginID;
	var password = args.password;

	require('network/socket').createSocket({
		hostname : hostname,
		port : port,
		loginID : loginID,
		password : password
	});
}

/*
 * Verarbeitet den Klick auf den connect Button
 */
function handleEvent(e) {
	var hostname = nameTextField.value;
	var port = portTextField.value;
	var loginID = loginNameTextField.value;
	var password = passwordTextField.value;

	/*
	 * Prüft ob IP-Adresse und Port angegeben sind.
	 */
	if (hostname == '' || port == '') {
		Ti.UI.createAlertDialog({
			title: L("errorLevel1"),
			message: L("errorCode1")
		}).show();
		return;
	}

	/*
	 * Prüft das Format der IP-Adresse.
	 */
	var objRegExp = /([0-9]{1,3})\.([0-9]{1,3})\.([0-9]{1,3})\.([0-9]{1,3})/;
	if (objRegExp.test(hostname) == false) {
		Ti.UI.createAlertDialog({
			title: L("errorLevel1"),
			message: L("errorCode2")
		}).show();
		return;
	}

	/*
	 * Verbindet sich mit dem TV-Gerät.
	 */
	connect({
		'hostname' : hostname,
		'port' : port,
		'loginID' : loginID,
		'password' : password
	});

	Ti.App.fireEvent('closeLoginWindow', {});
}

/*
 * Verarbeitet den Klick auf den cancel Button
 */
function handleCancelButton(e) {
	Ti.App.fireEvent('closeLoginWindow', {});
}