var image;
var volTimer;

/*
 * Generiert die Navigations View
 */
exports.createNavigationView = function(args) {
	var screenWidth = args.width;
	var height = args.height;
	var circleSize = 0.18 * screenWidth;
	var backgroundColor = 'transparent';

	var self = Ti.UI.createView({
		backgroundColor : 'black'
	});

	if(Ti.Platform.osname == 'ipad')
		var imageWidth = 0.7 * screenWidth;
	else if(args.changeOrientation)
		var imageWidth = 0.7 * screenWidth;
	else
		var imageWidth = 0.7 * screenWidth;

	var imageTop = height / 2 - imageWidth / 2;
	var imageLeft = screenWidth / 2 - imageWidth / 2;
	var fontSize = Ti.App.Properties.getInt('fontSize');
	image = Ti.UI.createImageView({
		image : '/images/navigationArea.png',
		width : imageWidth,
		height : imageWidth,
		top : imageTop,
		left : imageLeft,
		backgroundColor : 'black'
	});

	var buttonWidth = 0.15 * screenWidth;

	var navigationUpButton = Ti.UI.createButton({
		backgroundColor : backgroundColor,
		left : '27%',
		top : '19%',
		width : 3 * buttonWidth,
		height : buttonWidth,
		borderWidth : 0,
		id : 'navUp',
		style : Ti.UI.iPhone.SystemButtonStyle.PLAIN
	});

	var navigationDownButton = Ti.UI.createButton({
		backgroundColor : backgroundColor,
		left : '27%',
		top : '67%',
		width : 3 * buttonWidth,
		height : buttonWidth,
		borderWidth : 0,
		id : 'navDown',
		style : Ti.UI.iPhone.SystemButtonStyle.PLAIN
	});

	var navigationLeftButton = Ti.UI.createButton({
		backgroundColor : backgroundColor,
		left : '13%',
		top : '31%',
		width : buttonWidth,
		height : 3 * buttonWidth,
		borderWidth : 0,
		id : 'navLeft',
		style : Ti.UI.iPhone.SystemButtonStyle.PLAIN
	});

	var navigationRightButton = Ti.UI.createButton({
		backgroundColor : backgroundColor,
		left : '70%',
		top : '31%',
		width : buttonWidth,
		height : 3 * buttonWidth,
		borderWidth : 0,
		id : 'navRight',
		style : Ti.UI.iPhone.SystemButtonStyle.PLAIN
	});

	var okButtonWidth = '30%';
	var navigationOKButton = Ti.UI.createButton({
		backgroundColor : backgroundColor,
		width : okButtonWidth,
		height : okButtonWidth,
		id : 'navEnter',
		style : Ti.UI.iPhone.SystemButtonStyle.PLAIN
	});

	var homeButtonWidth = 0.3 * screenWidth;
	var homeButton = Ti.UI.createButton({
		backgroundImage : '/images/home.png',
		height : '10%',
		left : screenWidth / 2 - homeButtonWidth / 2,
		width : homeButtonWidth,
		top : '1%',
		id : 'menu',
		style : Ti.UI.iPhone.SystemButtonStyle.PLAIN
	});

	var threeDButton = Ti.UI.createButton({
		title : '3D',
		backgroundImage : '/images/3D.png',
		height : circleSize,
		left : imageLeft - circleSize / 2,
		width : circleSize,
		top : imageTop - circleSize / 2,
		id : '3D',
		style : Ti.UI.iPhone.SystemButtonStyle.PLAIN,
		font : {
			fontSize : fontSize
		}
	});

	var backButton = Ti.UI.createButton({
		title : 'Back',
		backgroundImage : '/images/buttonCircle.png',
		left : imageLeft + imageWidth - circleSize / 2,
		height : circleSize,
		width : circleSize,
		top : imageTop + imageWidth - circleSize / 2,
		id : 'back',
		style : Ti.UI.iPhone.SystemButtonStyle.PLAIN,
		font : {
			fontSize : fontSize
		}
	});

	var endButton = Ti.UI.createButton({
		title : 'END',
		backgroundImage : '/images/buttonCircle.png',
		left : imageLeft - circleSize / 2,
		height : circleSize,
		width : circleSize,
		top : imageTop + imageWidth - circleSize / 2,
		id : 'end',
		style : Ti.UI.iPhone.SystemButtonStyle.PLAIN,
		font : {
			fontSize : fontSize
		}
	});

	var epgButton = Ti.UI.createButton({
		title : 'EPG',
		backgroundImage : '/images/buttonCircle.png',
		left : imageLeft + imageWidth - circleSize / 2,
		width : circleSize,
		height : circleSize,
		top : imageTop - circleSize / 2,
		id : 'epg',
		style : Ti.UI.iPhone.SystemButtonStyle.PLAIN,
		font : {
			fontSize : fontSize
		}
	});

	navigationUpButton.addEventListener('click', handleClick);
	navigationDownButton.addEventListener('click', handleClick);
	navigationLeftButton.addEventListener('click', handleClick);
	navigationRightButton.addEventListener('click', handleClick);
	navigationOKButton.addEventListener('click', handleClick);
	homeButton.addEventListener('click', handleClick);
	threeDButton.addEventListener('click', handleClick);
	backButton.addEventListener('click', handleClick);
	endButton.addEventListener('click', handleClick);
	epgButton.addEventListener('click', handleClick);
	/*
	 navigationLeftButton.addEventListener('touchstart', handleTouchStart);
	 navigationLeftButton.addEventListener('touchend', handleTouchEnd);
	 navigationLeftButton.addEventListener('touchcancel', handleTouchCancel);
	 navigationRightButton.addEventListener('touchstart', handleTouchStart);
	 navigationRightButton.addEventListener('touchend', handleTouchEnd);
	 navigationRightButton.addEventListener('touchcancel', handleTouchCancel);*/

	self.add(image);
	self.add(navigationUpButton);
	self.add(navigationDownButton);
	self.add(navigationRightButton);
	self.add(navigationLeftButton);
	self.add(navigationOKButton);
	self.add(homeButton);
	self.add(threeDButton);
	self.add(epgButton);
	self.add(backButton);
	self.add(endButton);

	return self;
}
function handleLongClick(e) {

}

/*
 * Verarbeitet das längere Drücken des 3D Buttons
 */
function handleLongPress(e) {
	if(e.source.id == '3D') {
		require('ui/optionDialogs').show3DOptions();
	}
}

/*
 * Verarbeitet die Button clicks
 * Beim drücken der 5 Naviagtionstasten wird das darunterliegende Bild ausgestausch und nach ablauf des Timers zurückgesetzt
 */
function handleClick(e) {
	var id = e.source.id;

	if(id == 'navUp') {
		image.image = '/images/navigationAreaUpPress.png';
		setTimeout(revertImage, 500);
	} else if(id == 'navDown') {
		image.image = '/images/navigationAreaDownPress.png';
		setTimeout(revertImage, 500);
	} else if(id == 'navLeft') {
		image.image = '/images/navigationAreaLeftPress.png';
		setTimeout(revertImage, 500);
	} else if(id == 'navRight') {
		image.image = '/images/navigationAreaRightPress.png';
		setTimeout(revertImage, 500);
	} else if(id == 'navEnter') {
		image.image = '/images/navigationAreaOKPress.png';
		setTimeout(revertImage, 500);
	} else if( id = '3D') {
		require('ui/optionDialogs').show3DOptions();
		return;
	}

	Ti.App.fireEvent('sendMessage', {
		id : id
	});
}

function sendMessage(e) {
	Ti.App.fireEvent('sendMessage', {
		id : e.source.id
	});
}

/*
 * Beendet den Intervalltimer und setzt das Bild zurück
 */
function handleTouchEnd(e) {
	clearInterval(volTimer);
	volTimer = null;
	revertImage();
}

/*
 * Verarbeite das längere Drücken der Lautstärketasten
 * Solange die Taste gedrückt wird, wird in regelmäßigen Abständen eine Nachricht an den Fernseher gesendet
 */
function handleTouchStart(e) {
	var id = e.source.id;
	if(volTimer != null)
		return;

	if(id == 'navLeft') {
		image.image = '/images/navigationAreaLeftPress.png';
	} else if(id == 'navRight') {
		image.image = '/images/navigationAreaRightPress.png';
	}

	sendMessage(e);
	volTimer = setInterval(function() {
		sendMessage(e)
	}, 250);
}

/*
 * Beendet den Intervalltimer und setzt das Bild zurück
 */
function handleTouchCancel(e) {
	revertImage();
	clearInterval(volTimer);
	volTimer = null;
}

/*
 * Setzt das Bild zurück
 */
function revertImage() {
	image.image = '/images/navigationArea.png';
}