var numberTimer;
var number = '';
var animation;
var maxNumber = 3;
var buttonArray = new Array();

/*
 * Generiert den Zahlenblock
 */
exports.createNumericBlockView = function(args) {
	var height = args.height * 0.23;
	var width = args.width;
		
	var matrix = Ti.UI.create2DMatrix();
	matrix = matrix.scale(0.5);

	animation = Ti.UI.createAnimation({
		transform : matrix,
		duration : 200,
		autoreverse : true,
		repeat : 1
	});

	var view = Ti.UI.createView({
		separatorColor : 'transparent',
		backgroundColor : 'black'
	});

	//Define numeric buttons
	var button0 = Ti.UI.createButton({
		image : '/images/numberBlockZero.png',
		height : height,
		width : height,
		id : '0',
		anchorPoint : {
			x : 0.5,
			y : 0.5
		},
		top : 3 * height,
		left : width / 2 - height / 2
	});

	var button1 = Ti.UI.createButton({
		image : '/images/numberBlockOne.png',
		height : height,
		width : height,
		anchorPoint : {
			x : 0.5,
			y : 0.5
		},
		id : '1',
		top : 0,
		left : width / 2 - height / 2 - height
	});

	var button2 = Ti.UI.createButton({
		image : '/images/numberBlockTwo.png',
		height : height,
		width : height,
		id : '2',
		anchorPoint : {
			x : 0.5,
			y : 0.5
		},
		top : 0,
		left : width / 2 - height / 2
	});

	var button3 = Ti.UI.createButton({
		image : '/images/numberBlockThree.png',
		height : height,
		width : height,
		id : '3',
		anchorPoint : {
			x : 0.5,
			y : 0.5
		},
		top : 0,
		left : width / 2 + height / 2
	});

	var button4 = Ti.UI.createButton({
		image : '/images/numberBlockFour.png',
		height : height,
		width : height,
		id : '4',
		anchorPoint : {
			x : 0.5,
			y : 0.5
		},
		top : height,
		left : width / 2 - height / 2 - height
	});

	var button5 = Ti.UI.createButton({
		image : '/images/numberBlockFive.png',
		height : height,
		width : height,
		id : '5',
		anchorPoint : {
			x : 0.5,
			y : 0.5
		},
		top : height,
		left : width / 2 - height / 2
	});
	var button6 = Ti.UI.createButton({
		image : '/images/numberBlockSix.png',
		height : height,
		width : height,
		id : '6',
		anchorPoint : {
			x : 0.5,
			y : 0.5
		},
		top : height,
		left : width / 2 + height / 2
	});
	var button7 = Ti.UI.createButton({
		image : '/images/numberBlockSeven.png',
		height : height,
		width : height,
		id : '7',
		anchorPoint : {
			x : 0.5,
			y : 0.5
		},
		top : 2 * height,
		left : width / 2 - height / 2 - height
	});

	var button8 = Ti.UI.createButton({
		image : '/images/numberBlockEight.png',
		height : height,
		width : height,
		id : '8',
		anchorPoint : {
			x : 0.5,
			y : 0.5
		},
		top : 2 * height,
		left : width / 2 - height / 2
	});

	var button9 = Ti.UI.createButton({
		image : '/images/numberBlockNine.png',
		height : height,
		width : height,
		id : '9',
		anchorPoint : {
			x : 0.5,
			y : 0.5
		},
		top : 2 * height,
		left : width / 2 + height / 2
	});

	button0.addEventListener('click', handleClick);
	button1.addEventListener('click', handleClick);
	button2.addEventListener('click', handleClick);
	button3.addEventListener('click', handleClick);
	button4.addEventListener('click', handleClick);
	button5.addEventListener('click', handleClick);
	button6.addEventListener('click', handleClick);
	button7.addEventListener('click', handleClick);
	button8.addEventListener('click', handleClick);
	button9.addEventListener('click', handleClick);

	view.add(button1);
	view.add(button2);
	view.add(button3);
	view.add(button4);
	view.add(button5);
	view.add(button6);
	view.add(button7);
	view.add(button8);
	view.add(button9);
	view.add(button0);
	
	Ti.App.addEventListener('changeMaxNumber', changeMaxNumber);

	return view;
}

/*
 * Verarbeiten das Drücken der Zahlen
 * Nachricht wird erst nach Ablauf eines Timers gesendet, 
 * damit 1 - 4 stellige Programmnummern eingegeben werden können
 * Wenn die maximale Anzahl an Ziffern gedrückt wird, wird die Nachricht sofort gesendet
 */
function handleClick(e) {
	number += e.source.id;
	//e.source.animate(animation);
	var image = e.source.image.replace('.png', 'Pressed.png');
	Ti.API.info(image);
	e.source.image = image;

	if(numberTimer)
		clearTimeout(numberTimer);

	if(number.length == maxNumber)
		sendMessage();
	else
		numberTimer = setTimeout(sendMessage, 2000);
		
	setTimeout(revertImage, 500);
	buttonArray.push(e.source);
}

/*
 * Ändert die Anzahl an zulässaigen Stellen für die Programmnummer
 * (Abhängig vom ausgewählten Kanal)
 */ 
function changeMaxNumber(e){
	maxNumber = e.maxNumber;
}

/*
 * Setzt die Bilder der Ziffern auf den Ursprungszustand
 */
function revertImage()
{
	if (buttonArray.length > 0){
		var button = buttonArray.shift();
		var image = button.image.replace('Pressed.png', '.png');
		button.image = image;
	}
}

/*
 * Sendet die Nachricht und stoppt den Timer
 */
function sendMessage() {
	Ti.App.fireEvent('sendMessage', {
		id : 'progNumber',
		number : number
	});
	if(numberTimer)
		clearTimeout(numberTimer);
	number = '';
}