var selectedAVMode = 0, selected3DMode = 0, selectedVideoMode = 0;

/*
 * Generiert und zeigt einen Optionendialog für die AV Mode Auswahl
 */
exports.showAVModeOptions = function() {
	var dialog = Titanium.UI.createOptionDialog({
		title : 'AV Mode',
		options : ['Standard', 'Film', 'Spiele', 'Anwender', 'Dynamisch (Konstant)', 'Dynamisch', 'PC', 'x.v.Color', 'Standard (3D)', 'Film (3D)', 'Spiele (3D)', 'Auto']
	});

	var id = [];
	id[0] = 'standard';
	id[1] = 'film';
	id[2] = 'games';
	id[3] = 'user';
	id[4] = 'dynamicallyConst';
	id[5] = 'dynamically';
	id[6] = 'pc';
	id[7] = 'xvColor';
	id[8] = 'standard3D';
	id[9] = 'film3D';
	id[10] = 'games3D';
	id[11] = 'auto';

	dialog.addEventListener('click', function(e) {
		selectedAVMode = e.index;
		Ti.App.fireEvent('sendMessage', {
			id : id[e.index]
		});
	});

	dialog.setSelectedIndex(selectedAVMode);
	dialog.show();
}

/*
 * Generiert und zeigt einen Optionendialog für die 3D Mode Auswahl
 */
exports.show3DOptions = function() {
	var dialog = Titanium.UI.createOptionDialog({
		title : 'AV Mode',
		options : ['3D Off', '2D -> 3D', 'Nebeneinander', 'Übereinander', '3D -> 2D (Nebeneinander)', '3D -> 2D (Übereinander)', '3D Auto', '3D -> 2D']
	});

	var id = [];
	id[0] = '3DOff';
	id[1] = '2D/3D';
	id[2] = 'sideBySide';
	id[3] = 'oneUpTheOther';
	id[4] = '3D/2DsideBySide';
	id[5] = '3D/2DoneUpTheOther';
	id[6] = '3DAuto';
	id[7] = '3D/2D';

	dialog.addEventListener('click', function(e) {
		selected3DMode = e.index;
		Ti.App.fireEvent('sendMessage', {
			id : id[e.index]
		});
	});

	dialog.setSelectedIndex(selected3DMode);
	dialog.show();
}

/*
 * Generiert und zeigt einen Optionendialog für die Video Mode Auswahl
 */
exports.showVideoModeOptions = function() {
	var dialog = Titanium.UI.createOptionDialog({
		title : 'AV Mode',
		options : ['Normal', 'Zoom 14:9', 'Panorama', 'Voll (AV)', 'Kino 16:9', 'Kino 14:9', 'Normal (PC)', 'Kino (PC)', 'Voll (PC)', 'Punkt für Punkt (AV/PC)', 'Underscan (AV)', 'Auto', 'Original']
	});

	var id = [];
	id[0] = 'normal';
	id[1] = 'zoom14:9';
	id[2] = 'panorama';
	id[3] = 'full(AV)';
	id[4] = 'cinema16:9';
	id[5] = 'cinema14:9';
	id[6] = 'normal(PC)';
	id[7] = 'cinema(PC)';
	id[8] = 'full(PC)';
	id[9] = 'pointByPoint';
	id[10] = 'underscan';
	id[11] = 'auto';
	id[12] = 'original';

	dialog.addEventListener('click', function(e) {
		selectedVideoMode = e.index;
		Ti.App.fireEvent('sendMessage', {
			id : id[e.index]
		});
	});
	dialog.setSelectedIndex(selectedVideoMode);
	dialog.show();
}

/*
 * Generiert und zeigt einen Optionendialog für die Info Auswahl (nur iPhone)
 */
exports.showInfoDialog = function() {
	var dialog = Titanium.UI.createOptionDialog({
		title : 'Info',
		options : ['Login', 'Hilfe', 'Geräte Info']
	});

	dialog.addEventListener('click', function(e) {
		if(e.index == 0) {
			Ti.App.fireEvent('showLoginWindow', {});
		} else if(e.index == 1) {
			Ti.App.fireEvent('showHelpWindow', {});
		} else if (e.index == 2){
			Ti.App.fireEvent('showDeviceInfoWindow', {});
		}
	});
	
	dialog.show();
}