var volTimer;
var progTimer;

/*
 * Generiert die View, die permanent zu sehen ist
 */
exports.createPermanentView = function(args) {
	var viewHeight = args.height;
	var height = viewHeight * 0.32;
	var width = 0.25 * args.width;
	var fontSize = Ti.App.Properties.getInt('fontSizePerm');

	var view = Ti.UI.createView({
		backgroundColor : 'black',
		height : viewHeight,
		bottom : 0
	});

	var volumePlusButton = Ti.UI.createButton({
		title : 'V+',
		backgroundImage : '/images/buttonBig.png',
		height : height,
		width : width,
		id : 'volUp',
		style : 0,
		top : 0,
		left : width,
		style : Ti.UI.iPhone.SystemButtonStyle.PLAIN,
		font : {
			fontSize : fontSize
		}
	});

	var volumeMinusButton = Ti.UI.createButton({
		title : 'V-',
		backgroundImage : '/images/buttonBig.png',
		height : height,
		width : width,
		id : 'volDown',
		style : 0,
		top : height,
		left : width,
		style : Ti.UI.iPhone.SystemButtonStyle.PLAIN,
		font : {
			fontSize : fontSize
		}
	});

	var programPlusButton = Ti.UI.createButton({
		title : 'P+',
		backgroundImage : '/images/buttonBig.png',
		height : height,
		width : width,
		id : 'chUp',
		style : 0,
		top : 0,
		left : 2 * width,
		style : Ti.UI.iPhone.SystemButtonStyle.PLAIN,
		font : {
			fontSize : fontSize
		}
	});

	var programMinusButton = Ti.UI.createButton({
		title : 'P-',
		backgroundImage : '/images/buttonBig.png',
		height : height,
		width : width,
		id : 'chDown',
		style : 0,
		top : height,
		left : 2 * width,
		style : Ti.UI.iPhone.SystemButtonStyle.PLAIN,
		font : {
			fontSize : fontSize
		}
	});

	var muteButton = Ti.UI.createButton({
		title : 'Mute',
		backgroundImage : '/images/buttonBig.png',
		height : height,
		width : width,
		id : 'mute',
		style : 0,
		top : height,
		left : 0,
		style : Ti.UI.iPhone.SystemButtonStyle.PLAIN,
		font : {
			fontSize : fontSize
		}
	});

	var redButton = Ti.UI.createButton({
		//title:'Red',
		backgroundImage : '/images/red.png',
		height : height,
		width : width,
		id : 'red',
		style : 0,
		top : 2 * height,
		left : 0,
		style : Ti.UI.iPhone.SystemButtonStyle.PLAIN
	});

	var greenButton = Ti.UI.createButton({
		//title:'Green',
		backgroundImage : '/images/green.png',
		height : height,
		width : width,
		id : 'green',
		style : 0,
		top : 2 * height,
		left : width,
		style : Ti.UI.iPhone.SystemButtonStyle.PLAIN
	});

	var yellowButton = Ti.UI.createButton({
		//title:'Yellow',
		backgroundImage : '/images/yellow.png',
		height : height,
		width : width,
		id : 'yellow',
		style : 0,
		top : 2 * height,
		left : 2 * width,
		style : Ti.UI.iPhone.SystemButtonStyle.PLAIN
	});

	var blueButton = Ti.UI.createButton({
		//title:'Blue',
		backgroundImage : '/images/blue.png',
		height : height,
		width : width,
		id : 'blue',
		style : 0,
		top : 2 * height,
		left : 3 * width,
		style : Ti.UI.iPhone.SystemButtonStyle.PLAIN
	});

	var inputButton = Ti.UI.createButton({
		//title:'Input',
		backgroundImage : '/images/changeInput.png',
		height : height,
		width : width,
		id : 'changeInput',
		style : 0,
		top : 0,
		left : 3 * width,
		style : Ti.UI.iPhone.SystemButtonStyle.PLAIN
	});

	var channelBackButton = Ti.UI.createButton({
		//title:'Channel back',
		backgroundImage : '/images/channelBack.png',
		height : height,
		width : width,
		id : 'channelBack',
		style : 0,
		top : 0,
		left : 0,
		style : Ti.UI.iPhone.SystemButtonStyle.PLAIN
	});

	
	/*
	 var row1 = Ti.UI.createTableViewRow({
	 layout : 'horizontal',
	 height : viewHeight * 0.32,
	 width : '100%',
	 selectionStyle : Titanium.UI.iPhone.TableViewCellSelectionStyle.NONE
	 });

	 var row2 = Ti.UI.createTableViewRow({
	 layout : 'horizontal',
	 height : viewHeight * 0.32,
	 width : '100%',
	 selectionStyle : Titanium.UI.iPhone.TableViewCellSelectionStyle.NONE
	 });

	 var row3 = Ti.UI.createTableViewRow({
	 layout : 'horizontal',
	 height : viewHeight * 0.32,
	 width : '100%',
	 selectionStyle : Titanium.UI.iPhone.TableViewCellSelectionStyle.NONE
	 });

	 row1.add(channelBackButton);
	 row1.add(volumePlusButton);
	 row1.add(programPlusButton);
	 row1.add(inputButton);

	 row2.add(muteButton);
	 row2.add(volumeMinusButton);
	 row2.add(programMinusButton);
	 */

	view.add(channelBackButton);
	view.add(volumePlusButton);
	view.add(programPlusButton);
	view.add(inputButton);

	view.add(muteButton);
	view.add(volumeMinusButton);
	view.add(programMinusButton);

	view.add(redButton);
	view.add(greenButton);
	view.add(yellowButton);
	view.add(blueButton);

	/*
	 * Ersatz für den Android Optionenbutton für iPhone und iPad
	 */
	if(Ti.Platform.osname == 'iphone' || Ti.Platform.osname == 'ipad') {
		var helpButton = Ti.UI.createButton({
			text : '?',
			backgroundImage : '/images/buttonBig.png',
			height : height,
			width : width,
			id : 'help',
			style : 0,
			top : height,
			left : 3 * width,
			font : {
				fontSize : fontSize
			}
		});

		helpButton.addEventListener('click', handleClick);
		view.add(helpButton);

	}
	/*
	 row3.add(redButton);
	 row3.add(greenButton);
	 row3.add(yellowButton);
	 row3.add(blueButton);

	 var tableView = Ti.UI.createTableView({
	 layout : 'vertical',
	 separatorColor : 'transparent',
	 style : Titanium.UI.iPhone.TableViewStyle.PLAIN
	 });

	 tableView.appendRow(row1);
	 tableView.appendRow(row2);
	 tableView.appendRow(row3);

	 self.add(tableView);
	 */
	
	programMinusButton.addEventListener('click', handleClick);
	programPlusButton.addEventListener('click', handleClick);
	muteButton.addEventListener('click', handleClick);
	redButton.addEventListener('click', handleClick);
	greenButton.addEventListener('click', handleClick);
	blueButton.addEventListener('click', handleClick);
	yellowButton.addEventListener('click', handleClick);
	channelBackButton.addEventListener('click', handleClick);
	inputButton.addEventListener('click', handleClick);

	volumeMinusButton.addEventListener('touchstart', handleTouchStart);
	volumeMinusButton.addEventListener('touchend', handleTouchEnd);
	volumeMinusButton.addEventListener('touchcancel', handleTouchCancel);

	volumePlusButton.addEventListener('touchstart', handleTouchStart);
	volumePlusButton.addEventListener('touchend', handleTouchEnd);
	volumePlusButton.addEventListener('touchcancel', handleTouchCancel);
	
	return view;
}
/*
 * Verarbeite das längere Drücken der Lautstärketasten
 * Solange die Taste gedrückt wird, wird in regelmäßigen Abständen eine Nachricht an den Fernseher gesendet
 */
function handleTouchStart(e) {
	if(volTimer != null)
		return;

	sendMessage(e)
	volTimer = setInterval(function() {
		sendMessage(e)
	}, 250);
}

/*
 * Beendet den Intervalltimer und setzt das Bild zurück
 */
function handleTouchEnd(e) {
	clearInterval(volTimer);
	volTimer = null;
}

/*
 * Beendet den Intervalltimer und setzt das Bild zurück
 */
function handleTouchCancel(e) {
	clearInterval(volTimer);
	volTimer = null;
}

function sendMessage(e) {
	Ti.App.fireEvent('sendMessage', {
		id : e.source.id
	});
}

function handleClick(e) {
	if(e.source.id == 'help') {
		require('ui/optionDialogs').showInfoDialog();
	} else {
		Ti.App.fireEvent('sendMessage', {
			id : e.source.id
		});
	}

}