var views = [];
var self;
var nextImageIndex;

/*
 * Generiert die View, die die Navigations-, ExtMedia- und NumericBlockView beinhaltet
 * Ermöglicht das Wischen von einer View zur anderen
 */
exports.createSlideView = function(args) {

	var NavigationView = require('ui/navigationView');
	var ExtMediaView = require('ui/extMediaView');
	var NumericBlockView = require('ui/numericBlockView');

	var height = args.height;
	self = Ti.UI.createScrollableView({
		backgroundColor : 'black',
		height : height,
		top : args.top
	});

	var navigationView = NavigationView.createNavigationView({
		'height' : height,
		'width' : args.width,
		'changeOrientation' : args.changeOrientation
	});
	
	var extMediaView = ExtMediaView.createExtMediaView({
		'height' : height,
		'width' : args.width
	});

	var numericBlockView = NumericBlockView.createNumericBlockView({
		'height' : height,
		'width' : args.width
	});
	
	views = [navigationView, numericBlockView, extMediaView];

	self.setViews(views);

	return self;
}
